#!/bin/sh

#
# Install a file
# $1 = target file
# $2 = md5sum file
#

SRC_PATH=`realpath $1`
DST_PATH=`echo -n $1 | sed -e 's/^\.//'`
DST_DIR=`dirname $DST_PATH`
MD5_PATH=`realpath $2`

if [ -e $DST_PATH ] ; then
	cd $DST_DIR
	md5sum -c -s $MD5_PATH
	if [ $? -ne 0 ] ; then
		cp -f $SRC_PATH $DST_PATH
        	md5sum -c -s $MD5_PATH
                if [ $? -ne 0 ] ; then
                    echo -e  "${DST_PATH}  update FAILED" > /dev/console
                else
                    echo "${DST_PATH} updated" > /dev/console
                fi
	fi
else
	mkdir -p $DST_DIR
        cd $DST_DIR
	cp -f $SRC_PATH $DST_PATH
	md5sum -c -s $MD5_PATH
        if [ $? -ne 0 ] ; then
            echo -e  "${DST_PATH}  install FAILED" > /dev/console
        else
            echo "${DST_PATH} installed" > /dev/console
        fi
fi
