#!/bin/sh

actif=$1

#[Global]
#	Interface         Network Interface Name (eg. ALL / eth0,eth1,br0 / ath0)
#	SX Keep Alive     Enable / Disable
#
#[Default]            (Default Setting)
#	Baud Rate         300 / 600 / 1200 / 2400 / 4800 / 9600 / 14400 / 19200
#	                  38400 / 57600 / 115200 / 230400 / 460800 / 921600
#	Data Size         7 / 8
#	Parity            None / Odd / Even
#	Stop Bit          1 / 2
#	Flow Control Type None / Software / Hardware
#	Delay             0 - 65535 [msec]
#
#[ttyS0]             (Bus Name : Max 16Byte)
#	Path             (Device Path : Max 256 Byte)
#	Label            (Device Name : Max 32 Byte)
#	Type             (Device Type : RS-232C / RS-422 / RS-485)
#	Data Port        (TCP Port Number)
#	Command Port     (TCP Port Number)
#	Mode             (Serial DS Mode : Auto / Ecable / Mcast)
#	Ecable Mode      (Ecable Mode Flag : Enable / Disable : Def=Disable)
#	Ecable Level     (Ecable Mode Level : SX-520 / ExTech : Def=SX-520)
#	Ecable Host      (Ecabel Mode Host Name or IP Address : Max 256 Byte)
#	Ecable Interface (Ecabel Mode Network Interface Name : Max 16 Byte)
#	Mcast Mode       (Mcast Mode Flag : Enable / Disable : Def=Disable)
#	Mcast Direction  (Mcast Data Direction : recv / send / bidir : Def=recv)
#	Mcast Address    (Mcast Mode IP Address : Max 48 Byte)
#	Mcast Interface  (Mcast Mode Network Interface Name : Max 16 Byte)

BAUDRATE=`sxspsconf -r baud`
DATABITS=`sxspsconf -r bits`
STOPBITS=`sxspsconf -r stop`
PARITY=`sxspsconf -r parity`
FLOW=`sxspsconf -r flow`

case "$FLOW" in
XON_XOFF)
	FLOW="Software"
	;;
RTS_CTS)
	FLOW="Hardware"
	;;
esac

cat <<EOF > /tmp/sds.conf
[Global]
	Interface     = ${actif}
	SX Keep Alive = Enable

[Default]
	Baud Rate         = ${BAUDRATE}
	Data Size         = ${DATABITS}
	Parity            = ${PARITY}
	Stop Bit          = ${STOPBITS}
	Flow Control Type = ${FLOW}
	Delay             = 0

[ttySP0]
	Path          = /dev/ttySP0
	Label         = RS-232C Port
	Type          = 1
	Data Port     = 9191
	Command Port  = 9292
	Ecable Mode      = Disable
	Ecable Level     = SX-520
	Ecable Host      =
	Ecable Interface =
	Mcast Mode       = Disable
	Mcast Direction  = Recv
	Mcast Address    = 224.0.0.1
	Mcast Interface  =
EOF
