#!/bin/sh

PATH_CPUFREQ=/sys/devices/system/cpu/cpu0/cpufreq

mode=${1}

if ! grep -q userspace ${PATH_CPUFREQ}/scaling_available_governors 2>&1 /dev/null ; then
	echo "Not support userspace governor!" > /dev/console
	return
fi

#
# Set userspace governor
#
echo userspace > ${PATH_CPUFREQ}/scaling_governor

#
# Select cpu clock
#
case "$mode" in
'0') 
	cpufreq=64000
	;;
'1') 
	cpufreq=113684
	;;
'2') 
	cpufreq=261818
	;;
'3') 
	cpufreq=360000
	;;
'4') 
	cpufreq=454736
	;;
*)
	cpufreq=454736
	;;
esac

#
# Set cpu clock
#
echo "Set cpu clock to $cpufreq" > /dev/console
echo $cpufreq > ${PATH_CPUFREQ}/scaling_setspeed
