#!/bin/sh

if [ "$1" != "start" ] ; then
	exit 1
fi

ENETMODE=`ubootenv enetmode`

ifconfig eth0 0.0.0.0 up

case "${ENETMODE}" in
	"3")
		ENETMODE=10BASE
		ethtool -s eth0 autoneg off speed 10 duplex half
		;;
	"4")
		ENETMODE=100BASE
		ethtool -s eth0 autoneg off speed 100 duplex half
		;;
	"5")
		ENETMODE=FD100BASE
		ethtool -s eth0 autoneg off speed 100 duplex full
		;;
	"6")
		ENETMODE=FD10BASE
		ethtool -s eth0 autoneg off speed 10 duplex full
		;;
	*)
		ENETMODE=AUTO
		;;
esac

echo "eth0: Operating in ${ENETMODE} mode"
