#!/bin/sh

PATH=/sbin:/usr/sbin:/bin:/usr/bin
n=0
NORADIO=0

IFNAME=$1
CMD=$2
NORADIO=$3


jcpd_create_conf () {
	if [ $NORADIO -eq 0 ] ; then
		JCPD_PRODUCT=SD-320AN
		/bin/ln -fs /tmp/usr/www/cfg.def.wl /usr/share/context/cfg.def
#		/bin/ln -fs /usr/www/cfg.def.wl /usr/share/context/cfg.def
	else
		JCPD_PRODUCT=SD-300
		/bin/ln -fs /tmp/usr/www/cfg.def.wired /usr/share/context/cfg.def
#		/bin/ln -fs /usr/www/cfg.def.wired /usr/share/context/cfg.def
	fi
	/bin/ln -fs /tmp/usr/www/cfg_enum.dat /usr/share/context/cfg_enum.dat
#	/bin/ln -fs /usr/www/cfg_enum.dat /usr/share/context/cfg_enum.dat

cat <<EOF > /tmp/jcpd.conf
product=${JCPD_PRODUCT}
hostname=
netif=${IFNAME}
wireless if=wlan0
portnum=19540,19541
ds_port=19540
EOF

}

jcpd_start () {

	echo "Starting jcpd..." > /dev/console

	# Workaround for SVL wireless icon issue
	# This is unneeded if wlan0 is down in wired LAN mode
	if [ "$IFNAME" = "eth0" ] ; then
		ifconfig wlan0 down
		echo "    Stopping wlan0..." > /dev/console
	fi

	/usr/sbin/jcpd -f /tmp/jcpd.conf

	# Workaround for SVL wireless icon issue
	# This is unneeded if wlan0 is down in wired LAN mode
	if [ "$IFNAME" = "eth0" ] ; then
		sleep 2
		echo "    Starting wlan0..." > /dev/console
		ifconfig wlan0 up
	fi

}

jcpd_stop () {
	killall jcpd
	while [ $n -ne 10 ]
	do
		killall -0 jcpd
		if [ $? -ne 0 ] ; then
			break
		fi
		n=`expr $n + 1`
		sleep 1
	done
	if [ $n -eq 10 ] ; then
		echo "jcpd is not killed" > /dev/console
	fi
}

jcpd_restart () {
	killall -0 jcpd
	if [ $? -eq 0 ] ; then
		jcpd_stop
		jcpd_start
	fi

}

# ===================================================================
# Main #
# -------------------------------------------------------------------
case "${CMD}" in
'start')
	jcpd_create_conf
	jcpd_start
	;;
'stop')
	jcpd_stop
	;;
'restart')
	jcpd_restart
	;;
*)
	;;
esac