#!/bin/sh

if [ -z "$1" ]; then
   echo "Missing argument"
   exit 1
fi

USER=$1

mkdir -pv /tmp/jail
cd /tmp/jail
mkdir -pv bin sbin usr/bin usr/sbin dev/pts dev/shm proc etc lib usr/lib var/run var/log
mkdir -pv etc/appcerts upload

cp -P /lib/ld-uClibc* lib/
cp -P /lib/libuClibc* lib/
cp -P /lib/libcrypt* lib/
cp -P /lib/libc.so* lib/
cp -P /lib/libdl* lib/
cp -P /lib/libgcc* lib/
cp -P /lib/libm* lib/
cp -P /lib/libnsl* lib/
cp -P /lib/libpthread* lib/
cp -P /lib/libresolv* lib/
cp -P /lib/librt* lib/
cp -P /lib/libutil* lib/
cp -P /usr/lib/libz* lib/

cp /etc/resolv.conf etc/
cp /etc/services etc/
cp /etc/hosts etc/

touch var/log/lastlog var/log/wtmp var/run/utmp

mknod -m 666 dev/null c 1 3
mknod -m 666 dev/urandom c 1 9
mknod -m 666 dev/ptmx c 5 2
mknod -m 666 dev/tty c 5 0
chgrp tty dev/tty dev/ptmx

grep ^${USER} /etc/group > etc/group
grep ^tty /etc/group >> etc/group
grep root /etc/passwd > etc/passwd
grep ^${USER} /etc/passwd >> etc/passwd
grep ^${USER} /etc/shadow > etc/shadow

cp /etc/shells etc/
cp /etc/appcerts/db.key etc/appcerts/
chgrp tty dev/pts

cp /bin/busybox bin/
chmod u-s bin/busybox
ln -s /bin/busybox bin/sh
ln -s /bin/busybox bin/tftpd
ln -s /bin/busybox bin/telnetd
ln -s /bin/busybox bin/inetd
ln -s /bin/busybox bin/login
cp /usr/sbin/dropbear usr/sbin/
cp /usr/bin/console usr/bin/
chmod 777 upload

mount -o bind /dev/pts dev/pts/
mount -o bind /proc proc/
