#!/bin/sh

PATH=/usr/sbin:/bin:/usr/bin:/sbin
CONFHASH=/usr/sbin/sx_confhash
CONFPATH=/opt/.flash
IPFILTER=/etc/sxssi/ipfilter
CACRT=/etc/certs/ca.crt
CLCRT=/etc/certs/cl.crt
CLKEY=/etc/certs/cl.key
FW=update.bin
FWUP_SCRIPT=/usr/sbin/fwupdate.sh
FWUP_DIR=/tmp/smp_upload

OLDCONFHASH=/opt/.oldhash
OLDCONFMD5=/opt/.oldmd5

ret=0
case "$1" in
	'GET_CONFIG_HASH')
		# 4 digits
		#${CONFHASH} -f ${CONFPATH}
		#ret=$?
		flashhash=`${CONFHASH} -f ${CONFPATH}`
		ipfilhash=0
		if [ -e ${IPFILTER} ]; then
			ipfilhash=`${CONFHASH} -f ${IPFILTER}`
		fi
		cacrthash=0
		if [ -e ${CACRT} ]; then
			cacrthash=`${CONFHASH} -f ${CACRT}`
		fi
		clcrthash=0
		if [ -e ${CLCRT} ]; then
			clcrthash=`${CONFHASH} -f ${CLCRT}`
		fi
		clkeyhash=0
		if [ -e ${CLKEY} ]; then
			clkeyhash=`${CONFHASH} -f ${CLKEY}`
		fi
		ENETMODE=`ubootenv enetmode`
		#printf '%04x\n' $((0x$flashhash ^ 0x$ipfilhash ^ 0x$cacrthash ^ 0x$clcrthash ^ 0x$clkeyhash ^ 0x$ENETMODE))

		HASH=`printf '%04x' $((0x$flashhash ^ 0x$ipfilhash ^ 0x$cacrthash ^ 0x$clcrthash ^ 0x$clkeyhash ^ 0x$ENETMODE))`
		if [ -e ${CONFPATH}.md5 ]; then
			MD5=`cat ${CONFPATH}.md5`
		else
			MD5=`/usr/bin/md5sum ${CONFPATH}`
		fi
		OLDHASH=`cat ${OLDCONFHASH}`
		OLDMD5=`cat ${OLDCONFMD5}`
		if [ "${HASH}" = "${OLDHASH}" ]; then
			if [ "${MD5:0:32}" != "${OLDMD5:0:32}" ]; then
				HASH=`printf '%04x' $((0x$HASH ^ 0x${MD5:0:4}))`
			fi
		else
			if [ "${MD5:0:32}" = "${OLDMD5:0:32}" ]; then
				TMPHASH=`printf '%04x' $((0x$HASH ^ 0x${MD5:0:4}))`
				if [ "${OLDHASH}" = "${TMPHASH}" ]; then
					HASH=${OLDHASH}
				fi
			fi
		fi
		echo ${HASH} > ${OLDCONFHASH}
		echo ${MD5} > ${OLDCONFMD5}
		echo ${HASH}
		ret=0
		;;
	'IS_CONFIG_DEFAULT')
		# 0/1
		check=`/usr/sbin/sxspsconf -c SXFUN check_config_default`
		if [ "${check}" = "ChangedConfigure" ]; then
			ret=0
		fi
		if [ "${check}" = "FactoryDefault" ]; then
			ret=1
		fi
		echo $ret
		;;
	'FW_UPDATE')
		mv /tmp/${FW} ${FWUP_DIR}/${FW}
		${FWUP_SCRIPT} 0 ${FWUP_DIR} ${FW}
		ret=$?
		;;
	*)
		ret=1
		;;
esac
exit $ret
