#!/bin/sh

SYSLOGD=/sbin/syslogd
KLOGD=/sbin/klogd
LOGLEVEL=8
MAXLOGSIZE=32

syslogd_start() {
  if [ -x ${SYSLOGD} ]; then
    echo -n "Starting sysklogd daemons: " > /dev/console
    EXECSYSLOG="${SYSLOGD} -l ${LOGLEVEL} -s ${MAXLOGSIZE} -S"
    echo "${EXECSYSLOG}" > /dev/console
    ${EXECSYSLOG}
  fi
  if [ -x ${KLOGD} ]; then
    echo -n "Starting klogd daemons: " > /dev/console
    EXECKLOG="${KLOGD} -c ${LOGLEVEL}"
    echo "${EXECKLOG}" > /dev/console
    ${EXECKLOG}
  fi
}

syslogd_stop() {
  killall syslogd 2> /dev/null
  killall klogd 2> /dev/null
}

syslogd_restart() {
  syslogd_stop
  sleep 1
  syslogd_start
}

case "$1" in
'start')
  syslogd_start
  ;;
'stop')
  syslogd_stop
  ;;
'restart')
  syslogd_restart
  ;;
*)
  echo "usage $0 start|stop|restart"
esac
