#!/bin/sh

PATH=/sbin:/usr/sbin:/bin:/usr/bin

actif=${1}
CLONEMAC=${2}

WDOG_ACTION=/etc/init.d/wlan_watchdog.sh
WPA_SUPPLICANT_PID=/var/run/wpa_supplicant.pid

WLANWATCHDOG=1

# waits for the end of a rcW process.
while [ ! -e /tmp/init_complete ]
do
	echo "<WWR Wait>"
	sleep 1
done

if [ -e /tmp/ipconfig ] ; then
	. /tmp/ipconfig
fi

USENTP=${USENTP:-1}
USESXJCP=${USESXJCP:-1}
USESXFLDP=${USESXFLDP:-1}

if [ -r /etc/init.d/bridge.conf ] ; then
	. /etc/init.d/bridge.conf
	BRENABLE="${USEBRIDGE}"
fi

echo 0 > /sys/kernel/debug/ieee80211/phy0/ath6kl/force_passcan

if [ -e /etc/wpa_supplicant.conf ] ; then
	cp /etc/wpa_supplicant.conf /tmp/wpa_supplicant.conf
	if [ ${actif} = "br0" ] ; then
		wpa_supplicant -i wlan0 -B -c /tmp/wpa_supplicant.conf -b br0 -M ${CLONEMAC} -P ${WPA_SUPPLICANT_PID}
        elif [ ${actif} = "eth0" -a ${BRENABLE} = "0" ] ; then
		cp /etc/wpa_supplicant_null.conf /tmp/wpa_supplicant.conf
		wpa_supplicant -i wlan0 -B -c /tmp/wpa_supplicant.conf -P ${WPA_SUPPLICANT_PID}
		wpa_cli -B -i wlan0 -a /etc/init.d/wpa_action.sh
	else
		wpa_supplicant -i wlan0 -B -c /tmp/wpa_supplicant.conf -P ${WPA_SUPPLICANT_PID}
	fi
	WPA_COMMENT=`tail -n 1 /tmp/wpa_supplicant.conf`
	echo "Start wpa_supplicant : ${WPA_COMMENT}" > /dev/console

	# Watch Dog is enable, and wlan I/F is available
	if [ "${WLANWATCHDOG}" = "1" -a -e /sys/class/net/wlan0 -a -x /usr/sbin/sxwdogprcd ]; then
		cnt=0
		PID=""
		while [ $cnt -ne 30 ]; do
			if [ -e ${WPA_SUPPLICANT_PID} ]; then
				PID="`cat ${WPA_SUPPLICANT_PID}`"
				if [ "${PID}" != "" ]; then
					break
				fi
			fi
			usleep 100000
			cnt=`expr ${cnt} + 1`
		done
		/usr/sbin/sxwdogprcd -D -i 5 -a ${WDOG_ACTION} ${PID}
		echo "Start WLAN Watchdog timer($PID) count=${cnt}" > /dev/console
	fi
fi

# Multi client bridge start
if [ ${BRENABLE} = "2" ] ; then
	/etc/init.d/multicl_bridge.sh
fi

if [ $USESXJCP -ne "0" ] ; then
  if [ -x /usr/sbin/jcpd ] ; then
	/etc/init.d/jcpd.sh $actif start
  fi
fi

if [ $USESXFLDP -ne "0" ] ; then
  if [ -x /usr/sbin/fldpd ] ; then
	/usr/sbin/fldpd -D -i $actif
  fi
fi

